Application Server

The Application Server role in the Windows Server® 2008 operating system installs an application server that provides an integrated environment for deploying and running custom business applications that are built with Microsoft .NET Framework 3.0. Application Server includes services that support applications that are built to use COM+, Message Queuing, Web services, and Distributed Transactions.

  • Application Server Overview

  • Checklist: Create, Deploy, and Manage Dynamic Web Sites and Web-Based Applications

  • Checklist: Host Managed Applications

  • Checklist: Develop and Integrate Web Services into Your Environment

  • Checklist: Start Windows Communication Foundation Services When a Message Is Received

  • Checklist: Use TCP Port Sharing to Allow Multiple WCF Applications to Use the Same TCP Port

  • Checklist: Control Exposure to Critical Enterprise Services Applications

  • Checklist: Create Connected Applications in a Service-Oriented Architecture

  • Checklist: Model Business Processes and Workflows

  • Checklist: Enable the Distributed Transactions Service to Provide Transaction Support Across the Network

  • Installing and Configuring Application Server

  • Managing Application Server


Application Server Overview

Application Server provides an integrated environment for deploying and running custom business applications that are built with Microsoft .NET Framework 3.0. When you install the Application Server role, you can choose services that support applications that are built to use COM+, Message Queuing, Web services, and Distributed Transactions.

Application Server provides information technology (IT) professionals and developers with the following benefits:

  • A core runtime that supports effective deployment and management of high-performance business applications.

  • The .NET Framework development environment that delivers a simplified programming model and a high-performance execution model for server-based applications. The .NET Framework enables Web services and integrates new applications with existing applications and infrastructure.

  • A user-friendly installation wizard that provides choices for the various role services and features that you need to run applications in your organization.

  • Installation functionality that automatically installs the features that are required for a given role service.

Installation options

When you install the Application Server role on a server, you can add support for the following options:

  • Web Server

  • COM+ Network Access

  • Windows Process Activation Service

  • TCP Port Sharing

  • Distributed Transactions

Web Server

You can add Web Server support during Application Server installation. This option installs Internet Information Services (IIS), the Web server that is built into Windows Server 2008. IIS provides the following benefits:

  • IIS enables Application Server to host internal or external Web sites or services with static or dynamic content.

  • IIS supports ASP.NET applications that are accessed from a Web browser.

  • IIS supports Web services that are built with ASP.NET or Windows Communication Foundation (WCF).

COM+ Network Access

You can add COM+ Network Access during Application Server installation for remote invocation of applications that are built on and hosted within COM+ and Enterprise Services components. COM+ Network Access is one of the remote invocation capabilities of Windows Server 2008. Newer applications may use WCF to support remote invocation.

Windows Process Activation Service

You can add Windows Process Activation Service (WAS) support during Application Server installation. WAS can start and stop applications dynamically based on messages that are received over the network using Hypertext Transfer Protocol (HTTP), Message Queuing, TCP, and Named Pipes.

TCP Port Sharing

You can add the TCP Port Sharing role service during Application Server installation if you want multiple HTTP applications to use a single TCP port. When this feature is enabled, multiple WCF applications can share a single port for receiving incoming messages from the network. The Net.Tcp Port Sharing service accepts connections using the net.tcp protocol and automatically forwards incoming messages to the various WCF services based on the content of the messages. This simplifies the management of application servers where many instances of an application are running.

Distributed Transactions

You can add Distributed Transactions during Application Server installation to provide services that help ensure complete and successful transactions over multiple databases that are hosted on multiple computers on a network.

Additional references

  • Installing and Configuring Application Server


Checklist: Create, Deploy, and Manage Dynamic Web Sites and Web-Based Applications

Internet Information Services (IIS) in Windows Server 2008 is a full-featured Web server with a fault-tolerant process model that increases the reliability of Web sites and applications. Web application services are provided by ASP.NET, which integrates directly with IIS.

ASP.NET exposes a set of classes to provide complete functionality for building and deploying dynamic, Web-based applications. The reusable server controls in ASP.NET make possible a Hypertext Markup Language (HTML) style of declarative programming for building rich Web pages with less code.

Task | Reference
Review the features and functions of Web Server (IIS) Support for Application Server. Build and run Web sites and Web services with HTML and ASP.NET. | Web Server (IIS) Support for Application Server
Install the Application Server role on your server using the Add Roles Wizard. During Application Server installation, select the Web Server (IIS) Support option. | Install the Application Server Role on Your Server

Additional references

Installing and Configuring Application Server


Checklist: Host Managed Applications

In an environment of connected systems that are built on .NET Framework 3.0, deploying Application Server Foundation makes the seamless integration of systems possible. It also simplifies the deployment and operation of managed applications.

Task | Reference
Review the features and functions of Application Server Foundation. | Application Server Foundation Overview
Install Application Server Foundation on a single server using the Add Roles Wizard. | Install the Application Server Role on Your Server
Configure Application Server role services to support the applications that you will run. You may want to first install and run a test application that is designed to use the role services that you configure. Then, run the applications in your production environment. | Application Server Role Services

Additional references

Web Server (IIS) Support for Application Server

COM+ Network Access and Application Server

TCP Port Sharing and Application Server

Windows Process Activation Service Support for Application Server

Distributed Transaction Support for Application Server


Checklist: Develop and Integrate Web Services into Your Environment

You can develop scalable, interoperable Web services with the .NET Framework. You can then integrate these Web services into your existing environment with Internet Information Services (IIS). The .NET Framework and IIS provide the common development runtime and application server technology that Web application hosting requires.

Additional key components include Enterprise Services, such as transaction processing and message queuing, Web services, application management, security services, directory and data access, and application monitoring.

Task | Reference
Review the features and functions of Web Server (IIS) Support for Application Server. Build Web services with the .NET Framework and Windows Communication Foundation (WCF). | Web Server (IIS) Support for Application Server
Install the Application Server role on your server using the Add Roles Wizard. During Application Server installation, select the Web Server (IIS) Support option. When you select this option, Application Server installs Web server support that is preconfigured with a recommended set of default settings. These default settings provide a hosting environment that is suitable for Web applications and Web services. | Install the Application Server Role on Your Server
If necessary, configure Application Server role services with Windows Process Activation Service (WAS) to support the network protocols that are listed as WAS options and that are used by the WCF services in your hosting environment: Hypertext Transfer Protocol (HTTP), TCP, Named Pipes, and Message Queuing. | Windows Process Activation Service Support for Application Server

Additional references

  • For more information about ASP.NET, see Microsoft ASP.NET (http://go.microsoft.com/fwlink/?LinkID=8785).

  • For more information about Enterprise Services, see Microsoft Enterprise Services Overview (http://go.microsoft.com/fwlink/?LinkId=81259).

  • For more information about WCF, see What is Windows Communication Foundation? (http://go.microsoft.com/fwlink/?LinkId=81260).

  • For more information about WAS, see Hosting in WAS (http://go.microsoft.com/fwlink/?LinkId=81261).


Checklist: Start Windows Communication Foundation Services When a Message Is Received

The Listener Adapter for the various protocols listens for incoming messages and notifies Windows Process Activation Service (WAS) to activate the process in which the Windows Communication Foundation (WCF) process runs.

WAS can recycle the process after WCF services are finished so that the process can be used for another service. This saves processor and memory resources so that you can run more services on a single server.

Install WAS with the protocols that your WCF services use. These protocols can include Hypertext Transfer Protocol (HTTP), Message Queuing, TCP (TCP Activation), and Named Pipes.

Task | Reference
Review the features and functions of the WAS role services, and then identify the network protocols that your WCF applications use. WAS role services support the following protocols: HTTP, Message Queuing, TCP (TCP Activation), and Named Pipes. | Windows Process Activation Service Support for Application Server
Each application under the control of WAS has a Uniform Resource Identifier (URI) address that identifies the network protocol that WAS uses to activate the application. Protocols must be enabled per application. If your application's network protocol is supported by WAS, install the Application Server role on your server with the Add Roles Wizard. During Application Server installation, select the WAS role services for your application. Next, set the bindings for the application's protocol at the site level. | Install the Application Server Role on Your Server
If you select the option to enable TCP Activation, a firewall exception rule is created that opens TCP port 808. So that the TCP Listener can start listening on port 808, you must create a default Web site that uses net.tcp. | NetTcpBinding Class (http://go.microsoft.com/fwlink/?LinkId=93610)
Important

If you select any of the non-HTTP activation options, Application Server automatically creates a firewall exception rule that opens port 808. The firewall exception rule is required to use only TCP Activation. Therefore, if you are not planning to use TCP Activation, we recommend that you manually disable the firewall exception rule for port 808.

Additional references

  • Installing and Configuring Application Server


Checklist: Use TCP Port Sharing to Allow Multiple WCF Applications to Use the Same TCP Port

The Net.Tcp Port Sharing service makes it possible for multiple Windows Communication Foundation (WCF) services that are using the net.tcp protocol to listen on a single TCP port. Port sharing reduces the number of firewall exceptions that are necessary to host WCF services by allowing the use of common ports that are already open.

Task | Reference
Your application must use the Net.Tcp Port Sharing feature. The developer writes the application to use the NetTcpBinding binding (a .NET 3.0 Class) to connect WCF applications. WCF exposes port sharing as a configurable option on the binding. | How to: Configure a WCF Service to use Port Sharing (http://go.microsoft.com/fwlink/?LinkId=93846)
Review the features and functions of the Net.Tcp Port Sharing service. When port sharing is enabled, you can run the service multiple times without having a conflict over the port number. | TCP Port Sharing and Application Server
Enable port sharing on Application Server by installing the Application Server role with the Add Roles Wizard and selecting the TCP Port Sharing role service. | Install the Application Server Role on Your Server

Additional references

  • Installing and Configuring Application Server

  • For additional information about WCF, see What is Windows Communication Foundation? (http://go.microsoft.com/fwlink/?LinkId=81260).

  • For additional information about Net.Tcp, see NetTcpBinding Class (http://go.microsoft.com/fwlink/?LinkId=93610.


Checklist: Control Exposure to Critical Enterprise Services Applications

Enterprise Services applications typically offer critical middle-tier functionality. If your Enterprise Services applications reside on the same computer as the processes that call these applications, you can add an additional layer of security—beyond the security that role-based access controls offer—by disabling COM+ Network Access. Disabling COM+ Network Access prevents network access to all Enterprise Services applications.

Task | Reference
Review the features and functions of the COM+ Network Access role service. | COM+ Network Access and Application Server
If you installed Application Server with the COM+ Network Access role service enabled, you can disable this role service by removing it with the Remove Role Service Wizard. | Remove Application Server Role Services

Additional references

  • For more information about COM+ Network Access, see What's New in COM+ 1.5 (http://go.microsoft.com/fwlink/?LinkId=81264).


Checklist: Create Connected Applications in a Service-Oriented Architecture

Windows Communication Foundation (WCF) provides a framework for building secure, reliable, transacted, and interoperable distributed applications. WCF is a communications infrastructure that is built on the Web services architecture.

The service-oriented programming model of WCF is built into the Microsoft .NET Framework. It unifies a broad array of distributed systems capabilities in a composable and extensible architecture spanning transports, security systems, messaging patterns, encodings, network topologies, and hosting models.

WCF simplifies the development of connected systems by reducing the amount of custom coding.

Task | Reference
Review the features and functions of Application Server role services that are designed to support connected applications and facilitate communication over network protocols. These role services include Windows Process Activation Services (WAS), TCP Port Sharing, COM+ Network Access, Distributed Transaction Support, and Web Server (IIS) support. | Application Server Role Services
Identify the infrastructure necessary for connecting your applications and the Application Server role services that support it. Install the Application Server role using the Add Roles Wizard with the appropriate role services on each server that supports participating applications and resources. | Install the Application Server Role on Your Server

Additional references

  • For more information about WCF, see What is Windows Communication Foundation? (http://go.microsoft.com/fwlink/?LinkId=81260).

  • For more information about WAS, see Hosting in WAS (http://go.microsoft.com/fwlink/?LinkId=81261).

  • For more information about Net.Tcp Port Sharing, see Net.TCP Port Sharing (http://go.microsoft.com/fwlink/?LinkId=93614).


Checklist: Model Business Processes and Workflows

Developers can use Windows Workflow Foundation (WF) to describe business processes and human or system workflows with a simple, flowchart-type model.

WF supports a wide range of scenarios, including workflow in line-of-business (LOB) applications, user-interface (UI) page flow, document-centric workflow, human workflow, composite workflow for service-oriented applications, business-rule-driven workflow, and workflow for systems management.

After a model is compiled, it can be executed inside any Windows process. When business logic changes, you can apply updates to the process dynamically.

Task | Reference
Review the latest information about WF, the programming model, engine, and tools for quickly building workflow-enabled applications in Windows. WF consists of a .NET Framework version 3.0 namespace, an in-process workflow engine, and designers for Microsoft Visual Studio® 2005. | Windows Workflow Foundation Developer Center (http://go.microsoft.com/fwlink/?LinkId=93622)
Learn how to host workflows that are built with WF inside Windows Communication Foundation (WCF) services. | Integrating Windows Workflow Foundation and Windows Communication Foundation (http://go.microsoft.com/fwlink/?LinkId=93621)

Additional references

  • For more information about Windows Workflow Foundation, see Windows Workflow Foundation in the .NET Framework Developer Center (http://go.microsoft.com/fwlink/?LinkId=93624)


Checklist: Enable the Distributed Transactions Service to Provide Transaction Support Across the Network

An application that uses transactions can provide robust and reliable services despite system, process, or communication failures. Use of transactions guarantees that application and data states stay consistent and that all updates on the data are durable. These transaction semantics are preserved regardless of whether the data is local to the application or distributed across the network.

To allow transaction support for applications and resources across the network, enable the Distributed Transactions service in the Application Server role.

Task | Reference
Review the features and functions of distributed transaction support for Application Server. | Distributed Transaction Support for Application Server
Install the Application Server role on a server using the Add Roles Wizard. During Application Server role installation, make the appropriate selections for the Distributed Transactions service. | Install the Application Server Role on Your Server
Install the Application Server role with the Distributed Transactions option enabled on every server that hosts an application or a resource that will participate in the distributed transaction. | Install the Application Server Role on Your Server

Additional references

  • Installing and Configuring Application Server


Installing and Configuring Application Server

  • Choosing a Certificate for SSL Encryption

  • Application Server Foundation Overview

  • Install the Application Server Role on Your Server

  • Application Server Role Services

  • Web Server (IIS) Support for Application Server

  • COM+ Network Access and Application Server

  • TCP Port Sharing and Application Server

  • Windows Process Activation Service Support for Application Server

  • Distributed Transaction Support for Application Server


Choosing a Certificate for SSL Encryption

Secure Sockets Layer (SSL) encryption provides increased security for communication between client computers and the Web server support that hosts distributed applications. We strongly recommend that you use SSL with Application Server.

The list of certificates is filtered according to the key usages and enhanced key usages (EKUs) that are appropriate for the type of certificates that the role requires. If you import a certificate into the list that does not meet the key usage and EKU requirements, the imported certificate will not appear because it will be filtered from the list. For more information about how certificates work, see How Certificates Work (http://go.microsoft.com/fwlink/?LinkId=93630).

Important

If you use SSL encryption, you must have an SSL authentication certificate. If you have already obtained and installed an authentication certificate for the installation of Web server support for your distributed applications, you do not have to install another certificate. For a procedure to configure SSL on a Web server or a Web site, see IIS 7.0 Beta: Configuring Server Certificates in IIS 7.0 (http://go.microsoft.com/fwlink/?LinkID=64327).

Additional references

  • Installing and Configuring Application Server


Application Server Foundation Overview

Application Server Foundation is the group of technologies that are installed by default when you install the Application Server role. Essentially, Application Server Foundation is Microsoft .NET Framework 3.0.

Windows Server 2008 includes .NET Framework 2.0, regardless of any server role that is installed. .NET Framework 2.0 contains the Common Language Runtime (CLR), which provides a code-execution environment that promotes safe execution of code, simplified code deployment, and support for interoperability of multiple languages. Installing Application Server Foundation adds .NET Framework 3.0 features to the baseline .NET Framework 2.0. For more information about .NET Framework 3.0, see .NET Framework Developer Center (http://go.microsoft.com/fwlink/?LinkId=81263).

Application Server Foundation Components

The following are the key components of Application Server Foundation:

  • Windows Communication Foundation (WCF)

  • Windows Workflow Foundation (WF)

  • Windows Presentation Foundation (WPF)

Each component is installed as a set of libraries and .NET assemblies.

For server-based applications, the most valuable components of Application Server Foundation are WCF and WF. WPF is used primarily in client-based applications.

WCF

WCF is the Microsoft unified programming model for building applications that use Web services to communicate with each other. These applications are also known as service-oriented applications. Developers can use WCF to build secure, reliable, transacted applications that integrate across platforms and interoperate with existing systems and applications. For more information about WCF, see What is Windows Communication Foundation? (http://go.microsoft.com/fwlink/?LinkId=81260).

WF

WF is the programming model and engine for building workflow-enabled applications quickly on Windows Server 2008. WF includes support for both system workflow and human workflow across a variety of scenarios, including the following:

  • Workflow within line-of-business (LOB) applications

  • User interface (UI) page flow

  • Document-centric workflow

  • Human workflow

  • Composite workflow for service-oriented applications

  • Business-rule-driven workflow

  • Workflow for systems management

WPF

WPF provides a unified programming model for building rich Windows smart-client applications. As a component of .NET Framework 3.0, WPF is installed as a part of Application Server Foundation. However, it is not commonly used in server-based applications.

Additional references

  • Installing and Configuring Application Server


Install the Application Server Role on Your Server

Application Server provides information technology (IT) professionals and developers with an integrated environment for deploying and running custom business applications that are built with Microsoft .NET Framework 3.0. You can choose services that support applications that are built to use COM+, Message Queuing, Web services, and distributed transactions.

To install the Application Server role

  1. Click Start, and then click Server Manager.

  2. If the User Account Control dialog box appears, confirm that the action it displays is what you want, and then click Continue.

  3. On the Action menu, click Add Roles.

  4. The Add Roles Wizard appears. Click Next.

  5. The Select Server Roles page appears. Select the Application Server check box, and then click Next.

  6. Information about the Application Server role appears. Familiarize yourself with the information, and then click Next.

  7. On the Select Role Services page, select the role services that are necessary to run your applications, and then click Next. Application Server Foundation, the default role service, is always installed as a part of the Application Server role.

    Note

    Some role services require the installation of supporting features or role services from other roles. If this is the case, you have the option to install or not install the required features or role services.

  8. If the installation of a supporting feature or role service from another role is required, the next pages provide important information about the feature or set of features or role service. Click Next to go to the Confirm Installation Options page.

  9. Click Install to begin installing the Application Server role with the options that appear on the page. The installation process can be lengthy, depending on the role services that you select. After the installation process starts, input by the operator is not necessary. When the installation process is finished, the status of the installation appears on the Installation Results page.

Additional references

  • Installing and Configuring Application Server


Application Server Role Services

The applications that you deploy may require a set of supportive services, such as Message Queuing or Distributed Transactions support. The section of the Add Roles Wizard that adds the Application Server role includes a page for selecting the role services that are required to run your applications.

You can install the following role services, or support for these services, during Application Server installation:

  • Web Server (IIS) support: Application Server uses Web server support through Internet Information Services (IIS) to host internal or external Web sites and Web services that communicate over Hypertext Transfer Protocol (HTTP). This includes support for applications that are built on Microsoft ASP.NET that can be accessed through a Web browser such as Internet Explorer. It also includes support for Web services that are built with Windows Communication Foundation (WCF). For more information, see Web Server (IIS) Support for Application Server.

  • COM+ Network Access: Application Server uses COM+ Network Access to host and allow remote invocation of applications that are built with COM+ and Enterprise Services components. For more information, see COM+ Network Access and Application Server.

  • TCP Port Sharing: TCP Port Sharing facilitates the sharing of TCP ports across multiple processes that use WCF for communications. The default TCP port for sharing is port 808. For more information, see TCP Port Sharing and Application Server.

  • Windows Process Activation Service support: Application Server uses Windows Process Activation Service (WAS) support to invoke applications remotely over the network using protocols such as HTTP, Message Queuing, TCP, and Named Pipes. For more information, see Windows Process Activation Service Support for Application Server.

  • Distributed Transactions: Distributed Transactions helps ensure complete and successful transactions over multiple databases that are hosted on multiple computers on your network. For more information, see Distributed Transaction Support for Application Server.

Note

Some role services require the installation of a supporting feature or set of features. If this is the case, you have the option to install or not install the required feature or set of features.

Additional references

  • Installing and Configuring Application Server


Web Server (IIS) Support for Application Server

The Application Server installation process provides an option for adding Web server support. This option installs Internet Information Services (IIS), the Web server that is built into Windows Server 2008.

We recommend installing Web server support if you plan to host distributed applications that are built on Microsoft ASP.NET, Enterprise Services, or Windows Communication Foundation (WCF):

  • For more information about Microsoft ASP.NET, see Microsoft ASP.NET (http://go.microsoft.com/fwlink/?LinkID=8785).

  • For more information about Enterprise Services, see Microsoft Enterprise Services Overview (http://go.microsoft.com/fwlink/?LinkId=81259).

  • For more information about WCF, see What is Windows Communication Foundation? (http://go.microsoft.com/fwlink/?LinkId=81260).

Application Server installs Web server support that is preconfigured with a recommended set of defaults.

IIS 7.0 running on Windows Server 2008 uses Windows Process Activation Service (WAS) to enable activation and network communication over protocols other than Hypertext Transfer Protocol (HTTP). This environment is suitable for the development and hosting of WCF services that communicate over any network protocol that is supported by WCF, including HTTP, TCP, Named Pipes, and Message Queuing. For more information about WAS, see Hosting in WAS (http://go.microsoft.com/fwlink/?LinkId=81261).

Hosting WCF services in IIS has the following benefits:

  • Familiar deployment and management: WCF services that are hosted in IIS are deployed and managed like any other type of IIS application, including ASP.NET applications and ASMX Web Services.

  • Reliability and health management: IIS provides process activation, health management, and recycling capabilities to increase the reliability of hosted applications.

  • A shared hosting model: WCF services that are hosted in ASP.NET can take advantage of the ASP.NET shared hosting model where multiple applications reside in a common worker process for improved server density and scalability.

Note

WCF enables self-hosting of applications. Choose this hosting solution if it is a better fit for your application environment.

Additional references

  • Installing and Configuring Application Server


COM+ Network Access and Application Server

The Application Server role installation process provides an option for enabling COM+ Network Access. When COM+ Network Access is enabled, a firewall exception rule is created that opens port 135. The following sections describe situations in which you should enable COM+ Network Access. They also describe situations in which you should not enable COM+ Network Access.

Enabling COM+ Network Access

  • You should enable COM+ Network Access when one or more of the COM+ applications on the server are called from clients or applications that reside on different computers.

  • If your product collects COM+ performance data by remotely calling an object that tracks performance, you must enable COM+ Network Access.

Note

Enabling COM+ Network Access in Application Server does not automatically make COM+ applications remotely accessible. To ensure that a remote COM+ application is accessible, you must configure the application to use a static TCP endpoint.

Disabling COM+ Network Access

  • You should not enable COM+ Network Access if all the applications that are hosted in COM+ on the local computer are called only from other applications on the local computer, such as an ASP.NET page or a workflow. In this case, COM+ Network Access is not necessary, and leaving COM+ Network Access disabled helps reduce the attack surface area.

Additional references

  • Installing and Configuring Application Server

  • For more information about COM+ Network Access, see What's New in COM+ 1.5 (http://go.microsoft.com/fwlink/?LinkId=81264).

  • For information about configuring a COM+ application to use a static TCP endpoint, see Cannot set a fixed endpoint for a COM+ application (http://go.microsoft.com/fwlink/?LinkId=93633).

  • For information about COM+, see COM+ (Component Services) (http://go.microsoft.com/fwlink/?LinkId=93848).

  • For information about security and Web applications, see Securing Your Application Server (http://go.microsoft.com/fwlink/?LinkId=94263).


TCP Port Sharing and Application Server

The Application Server role installation process provides an option for turning on TCP Port Sharing. The Net.Tcp Port Sharing service, a new system component that is part of Windows Communication Foundation (WCF), enables TCP Port Sharing.

Applications can use TCP to communicate over public and private networks. Many applications on a single computer can use TCP for communication. The TCP/IP protocol uses a 16-bit number, called a port, to differentiate connections to multiple network applications that run on the same computer. If an application is listening on a port, all TCP traffic for that port goes to that application. Other applications cannot listen on that port at the same time.

Net.Tcp Port Sharing facilitates the sharing of TCP ports across multiple processes that use WCF for communication. When a WCF service that uses net.tcp:// port sharing opens, the WCF TCP transport infrastructure does not directly open a TCP socket in the application process. Instead, the transport infrastructure registers the service’s base address Uniform Resource Identifier (URI) with the Net.Tcp Port Sharing Service and waits for the port sharing service to listen for messages on its behalf. Messages that are addressed to the application service are dispatched by the port sharing service as they arrive.

Net.Tcp Port Sharing is transparent to remote applications that send messages. There is no need to make remote applications aware that Net.TCP Port Sharing is enabled.

As a security precaution, the Net.Tcp Port Sharing service is not enabled by default. To enable this service, select the TCP Port Sharing check box on the Select Role Services page during Application Server installation.

Additional references

  • Installing and Configuring Application Server


Windows Process Activation Service Support for Application Server

The Application Server installation process provides an option for selecting the Windows Process Activation Service (WAS) for applications that are built on Windows Communication Foundation (WCF). Installing WAS also installs the Web Server (IIS) role.

WAS is a new process activation mechanism for the Windows Server 2008 operating system that is also available on the Windows Vista® operating system. It retains the familiar Internet Information Services (IIS) 6.0 process model (application pools and message-based process activation) and hosting features (rapid failure protection, health monitoring, and recycling). However, it removes the dependency on Hypertext Transfer Protocol (HTTP) from the activation architecture. IIS 7.0 uses WAS to accomplish message-based activation over HTTP. In addition to HTTP, WCF can also use the non-HTTP protocols that are supported by WAS, such as TCP, MSMQ, and Named Pipes, to provide message-based activation. This makes it possible for applications that use communication protocols to take advantage of the IIS features, such as process recycling, rapid fail protection, and the common configuration system, that were previously available only to HTTP-based applications.

Each application that is under the control of WAS has a Uniform Resource Identifier (URI) address that identifies the network protocol that WAS uses to activate the application.

Note

For WAS activation to work, the network protocol that is specified in the URI must be enabled on the server and allowed to pass through any firewalls that are in place. For more information about allowing firewall exceptions, see Windows Firewall and Windows Firewall with Advanced Security (http://go.microsoft.com/fwlink/?LinkId=81757).

If you enable TCP Activation, Application Server creates a firewall exception rule that opens TCP port 808. (You can specify a different port by changing the URI to specify a different port.) So that the TCP Listener can start listening on port 808, you must also create a default Web site that uses net.tcp.

Additional references

  • Installing and Configuring Application Server


Distributed Transaction Support for Application Server

The installation process for the Application Server role provides an option for enabling the Distributed Transaction Coordinator (DTC). When you enable the DTC, Application Server automatically configures the DTC to allow network transactions. Application Server also creates a firewall rule that allows network traffic to pass to and from the DTC.

In information processing, a transaction is a series of operations that are treated as a single, atomic unit—all of the operations occur, or none of them occur. For example, a series of insert and update operations on a database might be committed as a transaction. In situations in which a transaction involves only a single resource, the resource manager itself (in this case, the database) can manage the entire transaction. In some situations, the operations in a transaction update data on multiple networked computers. This is called a distributed transaction. The DTC in Windows Server 2008 can coordinate the updates as a single transaction across resources that span multiple networked computers. For more information about the DTC, see Distributed Transaction Coordinator (http://go.microsoft.com/fwlink/?LinkId=93847).

Note

Application Server does not enable distributed transaction support by default. Ensure that the Application Server role is installed with the DTC option enabled on every server that hosts an application or a resource that will participate in the distributed transaction. These applications and resources can include an application that creates distributed transactions, an application that can participate in distributed transactions (such as a transactional COM+ component), and a resource (such as a database) that can participate in distributed transactions.

When you install the Application Server role, you can install the Distributed Transactions service with the following options:

  • Incoming Remote Transactions: In some situations, a distributed transaction is initiated on a remote computer, and an operation within the transaction involves a resource on the local computer. In this situation, we say that the transaction "flows into" the local computer and that the local resource (for example, a database) "enlists" in the transaction that was initiated on the remote computer. Enabling this option provides distributed transaction support for applications that enlist in remote transactions.

  • Outgoing Remote Transactions: In some situations, a local application initiates a transaction and performs update operations on resources that are located on remote computers. In this situation, we say that the transaction "flows out" of the local computer and is "propagated" to a resource on the remote computer. Enabling this option provides distributed transaction support for the outward propagation of transactions.

  • WS-Atomic Transaction Support: This option provides distributed transaction support for applications that use the Simple Object Access Protocol (SOAP) and the WS-Atomic Transaction standard for communication and transaction coordination.

Additional references

  • Installing and Configuring Application Server


Managing Application Server

  • Application Server Configurations

  • Add Application Server Role Services

  • Remove Application Server Role Services

  • Remove the Application Server Role


Application Server Configurations

  • Checklist: Create, Deploy, and Manage Dynamic Web Sites and Web-Based Applications

  • Checklist: Host Managed Applications

  • Checklist: Develop and Integrate Web Services into Your Environment

  • Checklist: Start Windows Communication Foundation Services When a Message Is Received

  • Checklist: Use TCP Port Sharing to Allow Multiple WCF Applications to Use the Same TCP Port

  • Checklist: Control Exposure to Critical Enterprise Services Applications

  • Checklist: Create Connected Applications in a Service-Oriented Architecture

  • Checklist: Model Business Processes and Workflows

  • Checklist: Enable the Distributed Transactions Service to Provide Transaction Support Across the Network


Add Application Server Role Services

You can add role services to the Application Server role anytime.

To add role services to the Application Server role

  1. Click Start, and then click Server Manager.

  2. If the User Account Control dialog box appears, confirm that the action it displays is what you want, and then click Continue.

  3. Under Roles Summary, click Application Server.

  4. Under Summary, click Add Role Services.

  5. On the Select Role Services page, select the additional role services that are necessary to run your applications, and then click Next.

    Note

    Some role services require the installation of supporting features or role services from other roles. If this is the case, you have the option to install or not install the required features or role services.

  6. If the installation of a supporting feature or role service from another role is required, the next pages provide information about the feature or role service. Click Next to proceed to the Confirm Installation Options page.

  7. Click Install to begin installing the Application Server role with the role services that appear on the page.

    The installation process can be lengthy, depending on the role services that you select. After the installation process starts, input by the operator is not necessary. When the installation process is finished, the status of the installation appears on the Installation Results page.

Additional references

  • Managing Application Server


Remove Application Server Role Services

You can remove role services anytime without deleting the Application Server role itself.

To remove role services from the Application Server role

  1. Click Start, and then click Server Manager.

  2. If the User Account Control dialog box appears, confirm that the action it displays is what you want, and then click Continue.

  3. Under Roles Summary, click Application Server.

  4. Under Summary, click Remove Role Services.

  5. On the Select Role Services page, clear the check boxes for the role services that you want to remove, and then click Next.

    Note

    Some role services require the removal of supporting features or role services from other roles. If this is the case, you must remove the supporting features or role services from the other roles to remove the role service.

  6. On the Confirm Removal Options page, click Remove to remove the role services that appear on the page. When the removal process is finished, the status of the removal appears on the Removal Results page.

Additional references

  • Managing Application Server


Remove the Application Server Role

If you no longer want to run an Application Server, you can remove the Application Server role from the server.

To remove the Application Server role from the server

  1. Click Start, and then click Server Manager.

  2. If the User Account Control dialog box appears, confirm that the action it displays is what you want, and then click Continue.

  3. Under Roles Summary, click Remove Roles.

  4. The Remove Roles Wizard appears with information about the process for removing a server role. Familiarize yourself with the information. If necessary, complete one or more recommended steps before continuing with the role removal process. When you are ready, click Next.

  5. On the Remove Server Roles page, clear the Application Server check box, and then click Next.

    Note

    Removing a server role sometimes requires the removal of a supporting role service or feature. If this is the case, you must remove the supporting service to completely remove the server role.

  6. On the Confirm Removal Options page, click Remove to remove the server role from the server. When the removal process is finished, the status of the removal appears on the Removal Results page.

Additional references

  • Managing Application Server